## ori 0.8.1%2Bds1

=== debian/changelog ===
ori (0.8.1+ds1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@ghraoui.name>  Mon, 28 Sep 2015 21:07:18 -0700

ori (0.8.1+ds1-1) unstable; urgency=low

  * Initial release (Closes: #792664)
  * Imported Upstream version 0.8.1+ds1
  * Ship additional files for docs and example
  * Account for third-party bundled software and exclude some of them
  * Set up autopkgtest

 -- Afif Elghraoui <afif@ghraoui.name>  Sat, 11 Jul 2015 18:39:19 -0700
