=== debian/control ===
Source: ori
Section: utils
Priority: optional
Maintainer: Afif Elghraoui <afif@ghraoui.name>
Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper (>= 9),
	       scons,
	       pkg-config,
	       libboost-dev,
	       uuid-dev,
	       libfuse-dev,
	       libevent-dev,
	       libssl-dev
Standards-Version: 3.9.6
Homepage: http://ori.scs.stanford.edu/index.html
Vcs-Git: git://anonscm.debian.org/users/afif-guest/ori.git
Vcs-Browser: http://anonscm.debian.org/cgit/users/afif-guest/ori.git/

Package: ori
Architecture: any
Depends: ${shlibs:Depends},
	 fuse,
	 ${misc:Depends}
Description: peer-to-peer distributed file system
 Ori is a distributed file system built for offline operation and empowers
 the user with control over synchronization operations and conflict resolution.
 History is provided through lightweight snapshots and users can verify that
 the history has not been tampered with. Through the use of replication,
 instances can be resilient and recover damaged data from other nodes.
