=== debian/tests/control ===
Test-Command: modprobe fuse && ./run-tests.sh
Depends: @, fuse
Restrictions: needs-root isolation-machine
