=== debian/watch ===
version=3

opts="repacksuffix=+ds1,dversionmangle=s/\+ds1//g" \
https://bitbucket.org/orifs/ori/downloads/ori(?:[_\-]v?|)(\d[^\s]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
